// Type definitions for @ag-grid-community/core v25.2.0
// Project: http://www.ag-grid.com/
// Definitions by: Niall Crosby <https://github.com/ag-grid/>
import { Component } from "../../widgets/component";
import { RowNode } from "../../entities/rowNode";
import { DragItem } from "../../dragAndDrop/dragAndDropService";
import { Beans } from "../beans";
import { Column } from "../../entities/column";
export interface IRowDragItem extends DragItem {
    defaultTextValue: string;
}
export declare class RowDragComp extends Component {
    private readonly rowNode;
    private readonly column;
    private readonly cellValueFn;
    private readonly beans;
    private readonly customGui?;
    private readonly dragStartPixels?;
    isCustomGui: boolean;
    private dragSource;
    constructor(rowNode: RowNode, column: Column, cellValueFn: () => string, beans: Beans, customGui?: HTMLElement | undefined, dragStartPixels?: number | undefined);
    private postConstruct;
    setDragElement(dragElement: HTMLElement, dragStartPixels?: number): void;
    private getSelectedCount;
    private checkCompatibility;
    private addDragSource;
    private removeDragSource;
}
